! A 15-bit Linear Feedback Shift Register
! By Nils M Holm, 2024
! In the public domain / under the 0BSD license

module rng;

 var State;

 ! b15 ^ b14

 public rand(k) do var x;
	x := State >> 1 ^ State & 1 << 14;
	State := State >> 1 | x;
	return State mod k;
 end

 public seed(x) State := x;

 public reseed(x) do
	State := State + x;
	if (State = 0) State := 1;
 end

 do
	seed(0xC0DE);
 end

end
